// generated by ../deps/sqlpp11/scripts/ddl2cpp privileges.sqlpp11.sql privileges wee
#ifndef WEE_PRIVILEGES_H
#define WEE_PRIVILEGES_H

#include <sqlpp11/table.h>
#include <sqlpp11/data_types.h>
#include <sqlpp11/char_sequence.h>

namespace wee
{
  namespace Privileges_
  {
    struct Project
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "project";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T project;
            T& operator()() { return project; }
            const T& operator()() const { return project; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Resource
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "resource";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T resource;
            T& operator()() { return resource; }
            const T& operator()() const { return resource; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Name
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T name;
            T& operator()() { return name; }
            const T& operator()() const { return name; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::require_insert>;
    };
    struct Description
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "description";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T description;
            T& operator()() { return description; }
            const T& operator()() const { return description; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::require_insert>;
    };
    struct Role
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "role";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T role;
            T& operator()() { return role; }
            const T& operator()() const { return role; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::can_be_null>;
    };
    struct RoleOrder
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "role_order";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T roleOrder;
            T& operator()() { return roleOrder; }
            const T& operator()() const { return roleOrder; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::can_be_null>;
    };
    struct RoleName
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "role_name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T roleName;
            T& operator()() { return roleName; }
            const T& operator()() const { return roleName; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::can_be_null>;
    };
    struct PermissionId
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "permission_id";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T permissionId;
            T& operator()() { return permissionId; }
            const T& operator()() const { return permissionId; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::can_be_null>;
    };
    struct Rank
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "rank";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T rank;
            T& operator()() { return rank; }
            const T& operator()() const { return rank; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::can_be_null>;
    };
    struct RankOrder
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "rank_order";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T rankOrder;
            T& operator()() { return rankOrder; }
            const T& operator()() const { return rankOrder; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::can_be_null>;
    };
    struct RankName
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "rank_name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T rankName;
            T& operator()() { return rankName; }
            const T& operator()() const { return rankName; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::can_be_null>;
    };
    struct Assigner
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "assigner";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T assigner;
            T& operator()() { return assigner; }
            const T& operator()() const { return assigner; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::can_be_null>;
    };
    struct AssignerFirstName
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "assigner_first_name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T assignerFirstName;
            T& operator()() { return assignerFirstName; }
            const T& operator()() const { return assignerFirstName; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::can_be_null>;
    };
    struct AssignerLastName
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "assigner_last_name";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T assignerLastName;
            T& operator()() { return assignerLastName; }
            const T& operator()() const { return assignerLastName; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::text, sqlpp::tag::can_be_null>;
    };
  } // namespace Privileges_

  struct Privileges: sqlpp::table_t<Privileges,
               Privileges_::Project,
               Privileges_::Resource,
               Privileges_::Name,
               Privileges_::Description,
               Privileges_::Role,
               Privileges_::RoleOrder,
               Privileges_::RoleName,
               Privileges_::PermissionId,
               Privileges_::Rank,
               Privileges_::RankOrder,
               Privileges_::RankName,
               Privileges_::Assigner,
               Privileges_::AssignerFirstName,
               Privileges_::AssignerLastName>
  {
    struct _alias_t
    {
      static constexpr const char _literal[] =  "privileges";
      using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
      template<typename T>
      struct _member_t
      {
        T privileges;
        T& operator()() { return privileges; }
        const T& operator()() const { return privileges; }
      };
    };
  };
} // namespace wee
#endif
